diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/rpc-auth-local/rpclocal.c ocamlnet-4.1.9.patched/src/rpc-auth-local/rpclocal.c
--- src/rpc-auth-local/rpclocal.c	2021-03-24 16:20:15
+++ src/rpc-auth-local/rpclocal.c	2026-05-29 06:31:44
@@ -12,6 +12,7 @@
 #include "caml/alloc.h"
 #include "caml/memory.h"
 #include "caml/fail.h"
+#include "caml/unixsupport.h"
 
 #ifndef _WIN32
 #include <unistd.h>
@@ -30,16 +31,7 @@
 
 
 /**********************************************************************/
-/* From unixsupport.h                                                 */
-/**********************************************************************/
 
-#define Nothing ((value) 0)
-
-extern void unix_error (int errcode, char * cmdname, value arg) Noreturn;
-extern void uerror (char * cmdname, value arg) Noreturn;
-
-/**********************************************************************/
-
 /* Inspired by PostgreSQL's fe-connect.c */
 
 value netsys_get_peer_credentials(value fd) {
@@ -58,7 +50,7 @@
     /* BSD, AIX, Cygwin */
     /* http://cr.yp.to/docs/secureipc.html */
     if (getpeereid(Int_val(fd), &uid, &gid) != 0) {
-	uerror("getpeereid", Nothing);
+	caml_uerror("getpeereid", Nothing);
     }
 
 #elif defined(SO_PEERCRED)
@@ -73,7 +65,7 @@
 		       SO_PEERCRED,
 		       &credentials,
 		       &len) == -1) {
-	    uerror("getsockopt",Nothing);
+	    caml_uerror("getsockopt",Nothing);
 	};
 	uid = credentials.uid;       /* Effective user ID */
 	gid = credentials.gid;       /* Effective group ID */
@@ -84,24 +76,24 @@
 	ucred_t    *ucred;
 	ucred = NULL;			/* must be initialized to NULL */
 	if (getpeerucred(Int_val(fd), &ucred) == -1) {
-	    uerror("getpeerucred",Nothing);
+	    caml_uerror("getpeerucred",Nothing);
 	};
 	if ((uid = ucred_geteuid(ucred)) == -1) {
-	    uerror("ucred_geteuid",Nothing);
+	    caml_uerror("ucred_geteuid",Nothing);
 	    ucred_free(ucred);
 	};
 	if ((gid = ucred_getegid(ucred)) == -1) {
-	    uerror("ucred_getegid",Nothing);
+	    caml_uerror("ucred_getegid",Nothing);
 	    ucred_free(ucred);
 	};
 	ucred_free(ucred);
     }
 #else
-    invalid_argument("get_peer_credentials");
+    caml_invalid_argument("get_peer_credentials");
 #endif
 
     /* Allocate a pair, and put the result into it: */
-    result = alloc_tuple(2);
+    result = caml_alloc_tuple(2);
     Store_field(result, 0, Val_int(uid));
     Store_field(result, 1, Val_int(gid));
 
@@ -140,7 +132,7 @@
 		       SO_PASSCRED,
 		       &one,
 		       sizeof(one)) < 0) {
-	    uerror("setsockopt", Nothing);
+	    caml_uerror("setsockopt", Nothing);
 	};
 
 	memset(&msg, 0, sizeof msg);
@@ -160,7 +152,7 @@
 	 */
 
 	if (recvmsg(Int_val(fd), &msg, MSG_PEEK) < 0) {
-	    uerror("recvmsg", Nothing);
+	    caml_uerror("recvmsg", Nothing);
 	};
 
 	if (msg.msg_controllen == 0 ||
@@ -201,12 +193,12 @@
 		       LOCAL_CREDS,
 		       &one,
 		       sizeof(one)) < 0) {
-	    uerror("setsockopt", Nothing);
+	    caml_uerror("setsockopt", Nothing);
 	};
 
 	memset(&msg, 0, sizeof msg);
 	crmsgsize = CMSG_SPACE(SOCKCREDSIZE(NGROUPS_MAX));
-	crmsg = stat_alloc(crmsgsize);
+	crmsg = caml_stat_alloc(crmsgsize);
 
 	memset(crmsg, 0, crmsgsize);
 	msg.msg_control = crmsg;
@@ -218,19 +210,19 @@
 	iov.iov_len = 1;
 
 	if (recvmsg(Int_val(fd), &msg, MSG_PEEK) < 0) {
-	    stat_free(crmsg);
-	    uerror("recvmsg", Nothing);
+	    caml_stat_free(crmsg);
+	    caml_uerror("recvmsg", Nothing);
 	};
 
 	if (msg.msg_controllen == 0 ||
 	    (msg.msg_flags & MSG_CTRUNC) != 0) {
-	    stat_free(crmsg);
+	    caml_stat_free(crmsg);
 	    raise_not_found();
 	};
 	cmp = CMSG_FIRSTHDR(&msg);
 	if (cmp->cmsg_level != SOL_SOCKET ||
 	    cmp->cmsg_type != SCM_CREDS) {
-	    stat_free(crmsg);
+	    caml_stat_free(crmsg);
 	    raise_not_found();
 	};
 
@@ -241,12 +233,12 @@
 	free(crmsg);
     }
 #else
-    invalid_argument("peek_peer_credentials");
+    caml_invalid_argument("peek_peer_credentials");
 #endif
 #endif
 
     /* Allocate a pair, and put the result into it: */
-    result = alloc_tuple(2);
+    result = caml_alloc_tuple(2);
     Store_field(result, 0, Val_int(uid));
     Store_field(result, 1, Val_int(gid));
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/shell/shell.ml ocamlnet-4.1.9.patched/src/shell/shell.ml
--- src/shell/shell.ml	2021-03-24 16:20:15
+++ src/shell/shell.ml	2026-05-29 06:31:44
@@ -111,8 +111,8 @@
 let from_string ?pos ?len ?epipe s =
   P_fun (Shell_sys.from_string ?pos:pos ?len:len ?epipe:epipe s);;
 
-let from_stream ?epipe s =
-  P_fun (Shell_sys.from_stream ?epipe:epipe s);;
+let from_seq ?epipe s =
+  P_fun (Shell_sys.from_seq ?epipe:epipe s);;
 
 let from_function ~producer () =
   P_fun producer;;
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/shell/shell.mli ocamlnet-4.1.9.patched/src/shell/shell.mli
--- src/shell/shell.mli	2021-03-24 16:20:15
+++ src/shell/shell.mli	2026-05-29 06:31:44
@@ -237,11 +237,11 @@
    *    always caught, and implicitly handled by closing the pipeline.
    *)
 
-val from_stream :
+val from_seq :
       ?epipe:(unit -> unit) ->     (* default: empty function *)
-      string Stream.t ->
+      string Seq.t ->
         producer
-  (** Creates a producer taking the data from a stream of strings.
+  (** Creates a producer taking the data from a sequence of strings.
    * After the data are sent, the pipeline is closed.
    *
    * @param epipe This function is called when the pipeline breaks
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/shell/shell_sys.ml ocamlnet-4.1.9.patched/src/shell/shell_sys.ml
--- src/shell/shell_sys.ml	2021-03-24 16:20:15
+++ src/shell/shell_sys.ml	2026-05-29 06:31:44
@@ -82,7 +82,7 @@
   try
     let k = ref 0 in
     iter_env_vars
-      (fun v' x' ->
+      ~f:(fun v' x' ->
 	 if v' = v then begin
 	   !e.(!k) <- v ^ "=" ^ x;
 	   raise Exit
@@ -100,7 +100,7 @@
   let x = ref "" in
   try
     iter_env_vars
-      (fun v' x' ->
+      ~f:(fun v' x' ->
 	 if v' = v then begin
 	   x := x';
 	   raise Exit
@@ -335,7 +335,7 @@
 ;;
 
 let dummy_process =
-  { p_command = command "XXX" ();
+  { p_command = command ~filename:"XXX" ();
     p_id = `Dummy;
     p_gid = 0;
     p_status = Some (Unix.WEXITED 0);
@@ -1103,7 +1103,7 @@
   from_tstring ?pos ?len ?epipe (`String s)
 
 
-let from_stream
+let from_seq
       ?(epipe = fun () -> ())
       s =
   let current_el  = ref None in
@@ -1112,6 +1112,8 @@
   let fd_style = ref `Read_write in
   let fd_style_set = ref false in
 
+  let stream = ref s in
+
   function fd ->
     if not !fd_style_set then (
       fd_style := Netsys.get_fd_style fd;
@@ -1120,14 +1122,15 @@
     (* If necessary, try to get the next stream element: *)
     begin match !current_el with
 	None ->
-	  begin try
-	    let x = Stream.next s in
-	    current_el := Some x;
-	    current_pos := 0;
-	  with
-	      Stream.Failure ->
-		()
-	  end
+        begin
+          match !stream() with
+            | Seq.Nil ->
+                ()
+            | Cons(x, tail) ->
+                stream := tail;
+                current_el := Some x;
+                current_pos := 0;
+          end
       | _ ->
 	  ()
     end;
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/shell/shell_sys.mli ocamlnet-4.1.9.patched/src/shell/shell_sys.mli
--- src/shell/shell_sys.mli	2021-03-24 16:20:15
+++ src/shell/shell_sys.mli	2026-05-29 06:31:44
@@ -417,13 +417,13 @@
         (Unix.file_descr -> bool)
   (** Same for tagged strings *)
 
-val from_stream :
+val from_seq :
       ?epipe:(unit -> unit) ->     (* default: empty function *)
-      string Stream.t ->
+      string Seq.t ->
         (Unix.file_descr -> bool)
-  (** [from_stream ?epipe s] returns a function which can be
+  (** [from_seq ?epipe s] returns a function which can be
    * used as [producer] argument for [add_producer]. The data transferred
-   * to the subprocess is taken from the string stream [s]. After these data
+   * to the subprocess is taken from the string sequence [s]. After these data
    * are sent, the pipeline is closed.
    *
    * @param epipe This function is called when the pipeline breaks
@@ -431,7 +431,7 @@
    *    always caught, and implicitly handled by closing the pipeline.
    *)
 
-val add_consumer : 
+val add_consumer :
       ?descr:Unix.file_descr ->     (* default: stdout *)
       consumer:(Unix.file_descr -> bool) ->
       command ->
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/tools/stubgen.ml ocamlnet-4.1.9.patched/tools/stubgen.ml
--- tools/stubgen.ml	2021-03-24 16:20:13
+++ tools/stubgen.ml	2026-05-29 06:31:44
@@ -447,7 +447,7 @@
   fprintf c "  CAMLparam0();\n";
   fprintf c "  CAMLlocal2(v,r);\n";
   if not abs.abs_nullok then
-    fprintf c "  if (x == NULL) failwith(\"wrap_%s: NULL pointer\");\n" tyname;
+    fprintf c "  if (x == NULL) caml_failwith(\"wrap_%s: NULL pointer\");\n" tyname;
   fprintf c "  v = caml_alloc_custom(&abs_%s_ops, \
                                      sizeof(struct absstruct_%s), 0, 1);\n"
          tyname tyname;
@@ -503,10 +503,10 @@
   try
     let l = String.length n in
     let p = String.index n '|' in
-    String.capitalize (String.lowercase (String.sub n (p+1) (l-p-1)))
+    String.capitalize_ascii (String.lowercase_ascii (String.sub n (p+1) (l-p-1)))
   with
     | Not_found ->
-         String.capitalize (String.lowercase n)
+        String.capitalize_ascii (String.lowercase_ascii n)
 
 
 let is_opt_case n =
@@ -550,7 +550,7 @@
     cases;
   fprintf c "    default: break;\n";
   fprintf c "  };\n";
-  fprintf c "  failwith(\"wrap_%s: unexpected value\");\n" tyname;
+  fprintf c "  caml_failwith(\"wrap_%s: unexpected value\");\n" tyname;
   fprintf c "}\n\n";
 
   fprintf c "static %s unwrap_%s(value v) {\n" tyname tyname;
@@ -568,9 +568,9 @@
          fprintf c "#endif\n"
     )
     cases;
-  fprintf c "    default: invalid_argument(\"unwrap_%s\");\n" tyname;
+  fprintf c "    default: caml_invalid_argument(\"unwrap_%s\");\n" tyname;
   fprintf c "  };\n";
-  fprintf c "  failwith(\"unwrap_%s: unexpected value\");\n" tyname;
+  fprintf c "  caml_failwith(\"unwrap_%s: unexpected value\");\n" tyname;
   fprintf c "}\n";
 
   if optional then
@@ -983,7 +983,7 @@
                   let i1 = new_local() in
                   c_decls := sprintf "long %s;" i1 :: !c_decls;
                   let code1 =
-                    [ sprintf "%s = (%s) stat_alloc(Wosize_val(%s)*sizeof(%s));" 
+                    [ sprintf "%s = (%s) caml_stat_alloc(Wosize_val(%s)*sizeof(%s));"
                               n1 c_ty n el_c_ty;
                       sprintf "for (%s=0; %s < Wosize_val(%s); %s++) {"
                               i1 i1 n i1;
@@ -1000,7 +1000,7 @@
                          sprintf "};"
                        ]
                      else []) @
-                      [ sprintf "stat_free(%s);" n1 ] in
+                      [ sprintf "caml_stat_free(%s);" n1 ] in
                   c_code_post_prio := List.rev code2 @ !c_code_post_prio;
              | `Array_size(n_array, ty) ->
                   let code =
@@ -1358,14 +1358,14 @@
       fprintf c "    long n__stub;\n";
       fprintf c "    %s__c++;\n" n_strbuf_size;
       fprintf c "    n__stub = %s__c;\n" n_strbuf_size;
-      fprintf c "    %s__c = stat_alloc(%s__c+1);\n" n_strbuf n_strbuf_size;
+      fprintf c "    %s__c = caml_stat_alloc(%s__c+1);\n" n_strbuf n_strbuf_size;
       fprintf c "    ";
       emit_call();
       fprintf c "    if (%s == 0) {\n" ret_var;
       fprintf c "      ((char *) %s__c)[n__stub] = 0;\n" n_strbuf;
       fprintf c "      %s = caml_copy_string(%s__c);\n" n_strbuf n_strbuf;
       fprintf c "    };\n";
-      fprintf c "    stat_free(%s__c);\n" n_strbuf;
+      fprintf c "    caml_stat_free(%s__c);\n" n_strbuf;
       fprintf c "  };\n";      
     )
     else (
@@ -1414,7 +1414,7 @@
 
   if optional then (
     fprintf c "#else\n";
-    fprintf c "  invalid_argument(\"%s\");\n" name;
+    fprintf c "  caml_invalid_argument(\"%s\");\n" name;
     fprintf c "#endif\n";
   );
 
@@ -1483,7 +1483,7 @@
 
 let gen_c_head2 c =
   fprintf c "static unsigned int uint_val(value v) {\n\
-             \032   if (Int_val(v) < 0) invalid_argument(\"negative integer\");\n\
+             \032   if (Int_val(v) < 0) caml_invalid_argument(\"negative integer\");\n\
              \032   return (unsigned int) Int_val(v);\n\
              }\n\
              \n\
